<?xml version="1.0" encoding="UTF-8"?>
<!-- XÖV-Profil 1.5.0 - XÖV-Übersetzungsanweisungen - XML Schema-Teil -->
<!-- $Id: xoev-profil.xmlschema.xsl 10434 2019-06-12 18:36:59Z mkuhlmann $ -->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:xmi="http://www.omg.org/spec/XMI/20131001" xmlns:xgen="http://www.xoev.de/de/xgenerator/framework/1/library" xmlns:xoev="http://www.xoev.de/de/xoev-profil/1_7_0" xmlns:xoev-sch="http://www.xoev.de/de/xoev-profil/schematron/1_7_0" xmlns:uml="http://www.eclipse.org/uml2/5.0.0/UML" xmlns:xd="http://www.oxygenxml.com/ns/doc/xsl" version="3.0" xmlns:sch="http://purl.oclc.org/dsdl/schematron" exclude-result-prefixes="xsl xmi xgen xoev xoev-sch uml xd">

    <xsl:template match="/" mode="xoev:default">
        <xsl:call-template name="xgen:result-document">
            <xsl:with-param name="local-path">
                <xsl:value-of select="concat($xoev:my-xmodel/xoev:xoevStandard(.)/@nameTechnisch, '-schematron.sch')"/>
            </xsl:with-param>
            <xsl:with-param name="content">
                <sch:schema queryBinding="xslt2">
                    <xsl:call-template name="xoev-sch:xsd-namespaces"/>
                    <sch:pattern>
                        <xsl:value-of select="xgen:unescaped-xml('&#xa;      ')"/>

                        <xsl:comment>Abstrakte Regeln</xsl:comment>
                        <xsl:value-of select="xgen:unescaped-xml('&#xa;      ')"/>
                        <xsl:apply-templates select="$xoev:my-xmodel//(packagedElement, nestedClassifier)[ownedRule]" mode="xoev-sch:abstract-rule-block">
                            <xsl:sort select="@name"/>
                        </xsl:apply-templates>

                        <xsl:comment>Konkrete Regeln</xsl:comment>
                        <xsl:call-template name="xoev-sch:concrete-rules"/>

                    </sch:pattern>
                </sch:schema>
<!--                <xsl:sequence select="$xoev-sch:message-trees"/>-->
<!--                <xsl:sequence select="$xoev-sch:rules-and-contexts"></xsl:sequence>-->
            </xsl:with-param>
        </xsl:call-template>
    </xsl:template>

    <xsl:template name="xoev-sch:xsd-namespaces" as="element()*">
        <xsl:variable name="namespaces">
            <namespaces>
                <xsl:for-each select="$xoev:my-xmodel//packagedElement[xoev:xsdSchema(.)]">
                    <namespace prefix="{xoev:getPrefix(.)}" uri="{xoev:getNamespace(.)}"/>
                    <xsl:for-each select="xoev:dependencies-by-client(.)[xoev:xsdImport(.)]">
                        <xsl:variable name="imported-schema" select="uml:resolve-supplier(.)"/>
                        <namespace prefix="{xoev:xsdImport(.)/@prefix[. != ''], $imported-schema/xoev:getPrefix(.)}" uri="{$imported-schema/xoev:getNamespace(.)}"/>
                    </xsl:for-each>                </xsl:for-each>
                <xsl:for-each select="$uml:root-model//packagedElement[xoev:xsdSchema(.)]">
                    <namespace prefix="{xoev:getPrefix(.)}" uri="{xoev:getNamespace(.)}"/>
                    <xsl:for-each select="xoev:dependencies-by-client(.)[xoev:xsdImport(.)]">
                        <xsl:variable name="imported-schema" select="uml:resolve-supplier(.)"/>
                        <namespace prefix="{xoev:xsdImport(.)/@prefix[. != ''], $imported-schema/xoev:getPrefix(.)}" uri="{$imported-schema/xoev:getNamespace(.)}"/>
                    </xsl:for-each>
                </xsl:for-each>
            </namespaces>
        </xsl:variable>
        <xsl:for-each select="$namespaces//namespace[not(@prefix = preceding-sibling::namespace/@prefix)]">
            <xsl:sort select="@prefix"/>
            <sch:ns prefix="{@prefix}" uri="{@uri}"/>
        </xsl:for-each>
    </xsl:template>

    <xsl:template match="packagedElement | nestedClassifier" mode="xoev-sch:abstract-rule-block">
        <xsl:comment select="
                concat(' ', xgen:model-path(.),
                if (xoev:schRuleSet(.)) then
                    ' (schRuleSet) '
                else
                    ' ')"/>
        <xsl:apply-templates select="ownedRule" mode="xoev-sch:abstract-rule">
            <xsl:sort select="@name"/>
        </xsl:apply-templates>
    </xsl:template>

    <xsl:template match="ownedRule" mode="xoev-sch:abstract-rule">
        <sch:rule id="{concat('rule-',@name)}" abstract="true">
            <sch:assert id="{@name}" test="{(specification/body, specification/@value)[1]}">
                <xsl:for-each select="ownedComment/body/xoev:clean-text(.)[. != '']">
                    <xsl:sort select="."/>
                    <xsl:value-of select="."/>
                </xsl:for-each>
            </sch:assert>
        </sch:rule>
    </xsl:template>

    <xsl:template name="xoev-sch:concrete-rules" as="element()*">
        <xsl:for-each select="distinct-values($xoev-sch:rules-and-contexts//full-paths/path/text())">
            <xsl:variable name="path" select="."/>
            <sch:rule context="{.}">
                <xsl:for-each select="$xoev-sch:rules-and-contexts//rule[context/full-paths/path = $path]">
                    <xsl:sort select="@name"/>
                    <sch:extends rule="{concat('rule-',@name)}"/>
                </xsl:for-each>
            </sch:rule>
        </xsl:for-each>
    </xsl:template>

</xsl:stylesheet>
